﻿# 人工的なデータを用いた線形回帰プログラム

# 必要なデータのインポート
import numpy as np
import matplotlib.pyplot as plt
from sklearn import linear_model, datasets

# 乱数によりデータを生成
#np.random.seed(0) # 乱数の種の生成？これがあると必ず同じ値が生成される
regdata=datasets.make_regression(100,1,noise=20.0) # 実際に乱数値を生成している

# 学習を行いモデルのパラメータを決定
lin=linear_model.LinearRegression() # インスタンスの生成
lin.fit(regdata[0],regdata[1]) # fittingの計算
print("coef and intercept：",lin.coef_,lin.intercept_) # 係数(coef_)、切片(intercept_)
print("score＝",lin.score(regdata[0],regdata[1])) # スコアの表示

# グラフを描画
xr=[-2.5,2.5]
plt.plot(xr,lin.coef_*xr+lin.intercept_) # 近似直線を引く
plt.scatter(regdata[0],regdata[1]) # データのプロット
plt.show()